package org.drools.cep;

import java.util.*;
import org.drools.model.*;
import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import java.time.*;
import java.time.format.*;
import java.text.*;
import org.drools.core.util.*;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import static org.drools.cep.RulesB3B1DB0632F3B1C43AC7D11E122555AB.*;

public class RulesB3B1DB0632F3B1C43AC7D11E122555ABRuleMethods0 {

    /**
     * Rule name: StockAverage
     */
    public static org.drools.model.Rule rule_StockAverage() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.Result> var_$r = D.declarationOf(org.kie.hacep.sample.kjar.Result.class,
                                                                                                   DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.org_kie_hacep_sample_kjar_Result_Metadata_INSTANCE,
                                                                                                   "$r");
        final org.drools.model.Variable<java.lang.String> var_$name = D.declarationOf(java.lang.String.class,
                                                                                      DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.java_lang_String_Metadata_INSTANCE,
                                                                                      "$name");
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_$pattern_StockTickEvent$1$ = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                                                   DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                                                   "$pattern_StockTickEvent$1$");
        final org.drools.model.Variable<Double> var_$p = D.declarationOf(Double.class,
                                                                         "$p");
        final org.drools.model.Variable<java.lang.Double> var_$avg = D.declarationOf(java.lang.Double.class,
                                                                                     DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.java_lang_Double_Metadata_INSTANCE,
                                                                                     "$avg");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockAverage").build(D.pattern(var_$r).bind(var_$name,
                                                                                         (_this) -> _this.getStockName(),
                                                                                         D.reactOn("stockName")),
                                                                  D.accumulate(D.pattern(var_$pattern_StockTickEvent$1$).expr("E2E77AA8A6CB5233369C5CC8F93A9A4D",
                                                                                                                              var_$name,
                                                                                                                              (_this, $name) -> org.drools.modelcompiler.util.EvaluationUtil.areNullSafeEquals(_this.getCompany(),
                                                                                                                                                                                                               $name),
                                                                                                                              D.betaIndexedBy(java.lang.String.class,
                                                                                                                                              org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                              DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                              _this -> _this.getCompany(),
                                                                                                                                              $name -> $name),
                                                                                                                              D.reactOn("company")).bind(var_$p,
                                                                                                                                                         (_this) -> _this.getPrice(),
                                                                                                                                                         D.reactOn("price")),
                                                                               D.accFunction(org.drools.core.base.accumulators.AverageAccumulateFunction::new,
                                                                                             var_$p).as(var_$avg)),
                                                                  D.on(var_$name,
                                                                       var_$r,
                                                                       var_$avg).execute(($name, $r, $avg) -> {
                                                                      System.out.println("Average price for " + $name + " is " + $avg);
                                                                      $r.setValue($avg);
                                                                  }));
        return rule;
    }

    /**
     * Rule name: StockLog
     */
    public static org.drools.model.Rule rule_StockLog() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_$stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                               DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                               "$stock");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockLog").build(D.pattern(var_$stock),
                                                              D.on(var_$stock).execute(($stock) -> {
                                                                  $stock.setProcessed(true);
                                                                  DroolsExecutor.getInstance()
                                                                                .execute(() -> {
                                                                                    String id = UUID.randomUUID()
                                                                                                    .toString();
                                                                                    System.out.println("Price for " + $stock.getCompany() + " is " + $stock.getPrice() + " id:" + id);
                                                                                    return id;
                                                                                });
                                                              }));
        return rule;
    }
}
